unit Pagebar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Consts;

type
  TPageBar = class(TScrollBar)
  private
    { Private declarations }
    FPage: cardinal;
    procedure SetPage(Value: cardinal);
    procedure SetScrollPage(Value:cardinal);
  protected
    { Protected declarations }
    procedure CreateWnd; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property Align;
    property Page: cardinal read FPage write SetPage default 25;
  end;

procedure Register;

implementation

constructor TPageBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPage:=25;
end;

procedure TPageBar.CreateWnd;
begin
  inherited CreateWnd;
  SetScrollPage(FPage);
end;

procedure TPageBar.SetScrollPage(Value:cardinal);
var
ScrollInfo:TScrollInfo;
begin
ScrollInfo.cbSize:=28;
ScrollInfo.nPage:=FPage;
ScrollInfo.fMask:=SIF_PAGE;
SetScrollInfo(Handle,SB_CTL,ScrollInfo,True);
end;

procedure TPageBar.SetPage(Value: cardinal);
begin

if Value>(Max-Min) then
   raise EInvalidOperation.CreateRes(SScrollBarRange);

if FPage<>Value then
   begin
      FPage:=Value;
      if HandleAllocated then
         SetScrollPage(FPage);
   end;
end;

procedure Register;
begin
  RegisterComponents('TreeSolutions', [TPageBar]);
end;

end.
